#include "gdal.h"  

#define GDAL_TYPE GDT_UInt32
#define TYPE      GUInt32
#define VAL_MAX   0xFFFFFFFF

int main(int argc, char* argv[])
{
    GDALAllRegister();
    GDALDriverH hDriver = GDALGetDriverByName("HFA");
    char* options [] = { "COMPRESSED=YES", NULL };
    GDALDatasetH hDS = GDALCreate(hDriver, "test_hfa.img", 64, 64, 1, GDAL_TYPE, options);
    TYPE anBuffer[64];
    int i;
    for(i=0;i<64;i++)
       anBuffer[i] = (i % 2) ? VAL_MAX : 0;
    for(i=0;i<64;i++)
    {
        GDALDatasetRasterIO(hDS,
                GF_Write,
                0,          //nXOff,
                i,             //nYOff,
                64,           //nXSize,
                1,           //nYSize,
                anBuffer,        //pData,
                64,             //nBufXSize,
                1,             //nBufYSize,
                GDAL_TYPE,     //eBufType,
                1,             //nBandCount,
                NULL,          //panBandMap,
                0,             //nPixelSpace,
                0,             //nLineSpace,
                0              //nBandSpace
        );
    }
    GDALClose(hDS);
    return 0;
}
